### Constructor

# EDataServer Source new

since: 3.6

#### Declaration [src]

    ESource*
    e_source_new (
      GDBusObject* dbus_object,
      GMainContext* main_context,
      GError** error
    )

#### Description [src]

Creates a new `ESource` instance.

The `ESource::changed` signal will be emitted from `main_context` if given, or else from the thread-default `GMainContext` at the time this function is called.

The only time the function should be called outside of `ESourceRegistry` is to create a so-called “scratch” `ESource` for editing in a Properties window or an account setup assistant.

FIXME: Elaborate on scratch sources.

Available since: 3.6

#### Parameters

`dbus_object`

  Type: `GDBusObject`

  A `GDBusObject` or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the function.

`main_context`

  Type: `GMainContext`

  A `GMainContext` or `NULL`.

  The argument can be `NULL`.
  The data is owned by the caller of the function.

`error`

  Type: `GError **`

  The return location for a recoverable error.

  The argument can be `NULL`.
  If the return location is not `NULL`, then you must initialize it to a `NULL` `GError*`.
  The argument will be left initialized to `NULL` by the constructor if there are no errors.
  In case of error, the argument will be set to a newly allocated `GError`; the caller will take ownership of the data, and be responsible for freeing it.

#### Return value

Type: `ESource`

A new `ESource`, or `NULL` on error.

The caller of the function takes ownership of the data, and is responsible for freeing it.